function testmasque
% Blaise Pascal University
% T. Chateau
% testmasque
% This function loads an image, add some noise,
% applies a filter and
% display the resulting filtered image
%
%%%%%%%%%%%
[x,map]=imread('Nenupharsb.jpg');               
I=double(x(:,:,1)); % extract red component
% apply random noise
[ty,tx]=size(I);
Amp=50; % Change here to modify the noise amplitude
Br=Amp.*randn(ty,tx)-Amp/2;
I=I+Br;
% Some classical kernels
% W=ones(11)./(11*11); % mean
% W=[-1 -1 -1 ; -1 8 -1 ; -1 -1 -1]; % laplacian 
W= gaus(7,2); % gaussian kernel (size ta and bandwidth sigma)
Im1=masqn(I,W); % Call masqn function
figure(1);colormap(gray);
subplot(1,2,1); % split the figure in 1 line and 2 columns
imagesc(I);
title('Initial image');
subplot(1,2,2);
imagesc(Im1);
title('Filtered image');

% End of main function

function W = gaus(ta,sigma)
% build a gaussian kernel
% ta: size of the kernel
% sigma: bandwidth
W=zeros(ta);
ta2=(ta-1)/2;
for i= -ta2:ta2
    for j= -ta2:ta2
        W(i+ta2+1,j+ta2+1)=exp(-(i^2+j^2)/(2*sigma^2));
    end
end
W = W./sum(W(:));
